package test;

import task1.AbstractRoadVehicle;
import task1.Boat;
import task1.Car;
import task1.IVehicle;
import task1.Motorcycle;
import task1.TestTask1;
import task1.Truck;
import task2.TestTask2;
import task3.TestTask3;

public class FerryApplication {
    public static int points;
    public static AbstractRoadVehicle[] roadVehicles;
    public static IVehicle[] vehicles;

    static {
        roadVehicles = new AbstractRoadVehicle[5];
        roadVehicles[0] = new Car("B-111-CAR");
        roadVehicles[1] = new Motorcycle("B-111-MOT");
        roadVehicles[2] = new Car("BV-222-CAR");
        roadVehicles[3] = new Truck("PH-111-TRK", 20);
        roadVehicles[4] = new Truck("B-222-TRK", 30);

        vehicles = new IVehicle[7];
        for (int i = 0; i < 5; i++) {
            vehicles[i] = roadVehicles[i];
        }
        vehicles[5] = new Boat();
        vehicles[6] = new Boat();

    }

    public static void main(String[] args) {
        try {
            TestTask1.test1();
        } catch (Exception e) {
            System.out.println("TASK1 : FAIL");
            System.out.print(e.getMessage());
        }

        try {
            TestTask2.test2();
        } catch (Exception e) {
            System.out.println("TASK2 : FAIL");
            printStack(e);
        }

        try {
            TestTask3.test3();
        } catch (Exception e) {
            System.out.println("TASK2 : FAIL");
            printStack(e);
        }

        System.out.print("\nPOINTS : " + points + "/10\n");
    }

    public static void printSeparator() {
        System.out.println("-----------------------------------------------------------------------------------------------------------------");
    }

    private static void printStack(Exception e) {
        for (int i = 0; i < e.getStackTrace().length; i++) {
            System.out.println(e.getStackTrace()[0]);
        }
    }
}
